/** @file fileio.h

	Skelton for retropc emulator

	@author Takeda.Toshiya
	@date   2006.08.18 -

	@brief [ file i/o ]
*/

#ifndef _FILEIO_H_
#define _FILEIO_H_

#include "common.h"

#define FILEIO_READ_BINARY		1
#define FILEIO_WRITE_BINARY		2
#define FILEIO_READ_WRITE_BINARY	3
#define FILEIO_READ_ASCII		4
#define FILEIO_WRITE_ASCII		5
#define FILEIO_READ_WRITE_ASCII		6
#define FILEIO_SEEK_SET			0
#define FILEIO_SEEK_CUR			1
#define FILEIO_SEEK_END			2

/**
	@brief file i/o
*/
class FILEIO
{
private:
	FILE* fp;

public:
	FILEIO();
	~FILEIO();
	bool IsProtected(const _TCHAR *filename);
	bool Fopen(const _TCHAR *filename, int mode);
	void Fclose();
	bool IsOpened() { return (fp != NULL); }
	int Fgetc();
	int Fputc(int c);
	char    *Fgets(char *buffer, int max_size);
	wchar_t *Fgets(wchar_t *buffer, int max_size);
	size_t Fread(void* buffer, size_t size, size_t count);
	size_t Fwrite(void* buffer, size_t size, size_t count);
	uint32 Fseek(long offset, int origin);
	uint32 Ftell();
	void Remove(_TCHAR *filename);
};

#endif
