/** @file configpanel.h

 HITACHI MB-S1 Emulator 'EmuB-S1'
 Skelton for retropc emulator
 SDL edition + Cocoa GUI

 @author Sasaji
 @date   2015.04.30 -

 @brief [ config panel ]
 */

#ifndef _COCOA_CONFIGPANEL_H_
#define _COCOA_CONFIGPANEL_H_

#import <Cocoa/Cocoa.h>
#import "cocoa_basepanel.h"
#import "../../vm/vm.h"

@interface CocoaConfigPanel : CocoaBasePanel
{
	CocoaRadioGroup *radSysMode;
	CocoaRadioGroup *radFddType;
	CocoaCheckBox *chkFddMount[MAX_DRIVE];
	CocoaCheckBox *chkIOPort[8];

	CocoaPopUpButton *popUseOpenGL;
	CocoaPopUpButton *popGLFilter;
	CocoaPopUpButton *popLEDPosition;
	CocoaPopUpButton *popCurdispSkew;
	CocoaPopUpButton *popDisptmgSkew;

	CocoaTextField *txtSnapPath;
	CocoaTextField *txtFontPath;
	CocoaTextField *txtMsgFontName;
	CocoaTextField *txtMsgFontSize;
	CocoaTextField *txtInfoFontName;
	CocoaTextField *txtInfoFontSize;

	CocoaCheckBox *chkReverseWave;
	CocoaCheckBox *chkHalfWave;
	CocoaCheckBox *chkCorrectWave;
	CocoaRadioGroup *radCorrect;

	CocoaPopUpButton *popSampleRate;
	CocoaPopUpButton *popSampleBits;

	CocoaTextField *txtLPTHost[MAX_PRINTER];
	CocoaTextField *txtLPTPort[MAX_PRINTER];
	CocoaTextField *txtCOMHost[MAX_COMM];
	CocoaTextField *txtCOMPort[MAX_COMM];
	CocoaPopUpButton *popCOMDipswitch[MAX_COMM];

	CocoaTextField *txtROMPath;
	CocoaPopUpButton *popExtRam;

}
- (id)init;
- (NSInteger)runModal;
- (void)close;
- (void)dialogCancel:(id)sender;
- (void)dialogOk:(id)sender;
- (void)showFolderPanel:(id)sender;
- (void)showFilePanel:(id)sender;
- (void)showFontPanel:(id)sender;
- (void)changeFont:(id)sender;

- (void)selectFddType:(CocoaRadioGroup *)sender;
- (void)selectIO:(CocoaCheckBox *)sender;
- (void)selectCorrect:(CocoaCheckBox *)sender;
@end

#endif /* _COCOA_CONFIGPANEL_H_ */
